<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\InvoiceMaster;
use App\Models\User;

class InvoiceMasterPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any InvoiceMaster');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, InvoiceMaster $invoicemaster): bool
    {
        return $user->checkPermissionTo('view InvoiceMaster');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create InvoiceMaster');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, InvoiceMaster $invoicemaster): bool
    {
        return $user->checkPermissionTo('update InvoiceMaster');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, InvoiceMaster $invoicemaster): bool
    {
        return $user->checkPermissionTo('delete InvoiceMaster');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any InvoiceMaster');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, InvoiceMaster $invoicemaster): bool
    {
        return $user->checkPermissionTo('restore InvoiceMaster');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any InvoiceMaster');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, InvoiceMaster $invoicemaster): bool
    {
        return $user->checkPermissionTo('replicate InvoiceMaster');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder InvoiceMaster');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, InvoiceMaster $invoicemaster): bool
    {
        return $user->checkPermissionTo('force-delete InvoiceMaster');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any InvoiceMaster');
    }
}
